
/*
 * Programmieren fuer Physiker, SS 2023, Blatt 09, Aufgabe 24
 *
 * Borduere: Rekursives Ermitteln aller Moeglichkeiten
 */

#include <iostream>
using namespace std ;

long nr_configs( int len, int lasttile)
// arguments: len: remaining length, 
//            lasttile: code(=length) of last used tile.
// if there has been no tile yet, lasttile is zero.
// return value: nr of configurations with these parameters
{
    if (len<0) return 0 ;// terminating cases
    if (len==0) return 1 ;  

    long c = 0 ;  // sum up number of configurations
    if (lasttile!=1)
	c += nr_configs( len-1, 1) ;
    if (lasttile!=2)
	c += nr_configs( len-2, 2) ;
    if (lasttile!=3)
	c += nr_configs( len-3, 3) ;
    // shorter: for( int l=1; l<=3; ++l)
    //            if (l!=lasttile) 
    //              c+=nr_configs(len-l,l) 
    return c ;
}

long nr_configs( int len)
{
    return nr_configs( len, 0) ; // 0 as lasttile
}

int main()
{
    cout << "Die Borduere" << endl ;

    for( int i=0; i<=30; ++i)
	cout << "Laenge: " << i 
	     << "  Anzahl der Konfigurationen: " << nr_configs(i) << endl ;
}
